-- name: [CS] Phineas
-- description: I know what were gonna do today! \n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
	(This is an edited version of the Template File by Squishy)
]]

local TEXT_MOD_NAME = "CHARNAME"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_CUSTOM_MODEL = smlua_model_util_get_id("phineas_geo") -- Located in "actors"

local TEX_CUSTOM_LIFE_ICON = get_texture_info("phinicon") -- Located in "textures"

-- All Located in "sound" Name them whatever you want. Remember to include the .mp3 extension
local VOICETABLE_CHARNAME2 = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'phinletsgo.mp3', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'phinletsgo.mp3', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'phinyah.mp3', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'phinwah.mp3', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'phinhoo.mp3', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'phinyah.mp3', 'phinwah.mp3', 'phinhoo.mp3'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'phinwah.mp3', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'phinwoohoo.mp3', 'phinwoohoo.mp3'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'phindoh.mp3', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Silent.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'phinwoohoo.mp3', -- Long jump
	[CHAR_SOUND_DOH] = 'phindoh.mp3', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'phinhuh.mp3', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'phinhuh.mp3', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'phinwoho.mp3', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'phinhuh.mp3', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'phinhuh.mp3', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'phinwoohoo.mp3', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'greatidea.mp3', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'phindoh.mp3', -- Damaged
	[CHAR_SOUND_PANTING] = 'phincough.mp3', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'phinwoho.mp3', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Snore.mp3', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'phincough.mp3', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Silent.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Silent.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'phinpain.ogg' -- Booted out of level
}

-- All Located in "actors"
local CAPTABLE_CHAR = {
    normal = smlua_model_util_get_id("uniqueCAP_geo"),
    wing = smlua_model_util_get_id("uniquegeeseWING_geo"),
    metal = smlua_model_util_get_id("uniqueMETAL_geo"),
}

local PALETTE_CHAR = {
    [PANTS]  = "585858",
    [SHIRT]  = "7A38B0",
    [GLOVES] = "ffffff",
    [SHOES]  = "30203A",
    [HAIR]   = "8D6625",
    [SKIN]   = "FEC179",
    [CAP]    = "7A38B0",
	[EMBLEM] = "ffffff"
}

local HM_CHARNAME2= {
    label = {
        left = get_texture_info("empty"),
        right = get_texture_info("empty"),
    },
    pie = {
        [1] = get_texture_info("cangreen4"),
        [2] = get_texture_info("cangreen3"),
        [3] = get_texture_info("cangreen2"),
        [4] = get_texture_info("cangreen2"),
        [5] = get_texture_info("cangreen1"),
        [6] = get_texture_info("cangreen1"),
        [7] = get_texture_info("cangreen"),
        [8] = get_texture_info("cangreen"),
    }
}

local CSloaded = false
local function on_character_select_load()
    CT_CHARNAME2 = _G.charSelect.character_add("Phineas", {"So Stick with us cause Phineas and Ferb are gonna do it all!"}, "Mod Creator Name", {r = 255, g = 200, b = 200}, E_MODEL_CUSTOM_MODEL, CT_CHARNAME2, TEX_CUSTOM_LIFE_ICON)
    _G.charSelect.character_add_caps(E_MODEL_CUSTOM_MODEL, CAPTABLE_CHAR)
    _G.charSelect.character_add_voice(E_MODEL_CUSTOM_MODEL, VOICETABLE_CHARNAME2)
    _G.charSelect.character_add_celebration_star(E_MODEL_CUSTOM_MODEL, E_MODEL_CUSTOM_STAR, TEX_CUSTOM_STAR_ICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_CUSTOM_MODEL, PALETTE_CHAR)
    _G.charSelect.character_add_health_meter(CT_CHARNAME2, HM_CHARNAME2)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHARNAME2 then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHARNAME2 then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)